#!/bin/sh
# ----------------------------------------------------------------------------
# /tmp/install.sh - installation file for owswitch services on EIS/FAIR
#
# Copyright (c) 2016-2016 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation   : 2016-06-13 jed
# Last update: $Id: install.sh 42321 2016-07-17 16:26:07Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# ----------------------------------------------------------------------------

# include eislib
. /var/install/include/eislib
. /var/install/include/check-eisfair-version
. /var/install/include/jedlib

#exec 2> /tmp/owswitch-install-trace$$.log
#set -x

# set package name
module_name='owswitch'

mecho --info "running install.sh ..."

# update shared library file
update_jedlib ${module_name}

configfile=/etc/config.d/${module_name}
installfile=/var/run/${module_name}.install

if [ -f ${configfile} ]
then
    # load default configuration
    . ${configfile}
elif [ -f ${installfile} ]
then
    # load configuration during update
    . ${installfile}
fi

### symbolic links
mecho "creating symbolic links ..."
rm -f /etc/rc2.d/[KS]??${module_name}

ln -sf /etc/init.d/${module_name} /etc/rc2.d/K10${module_name}
ln -sf /etc/init.d/${module_name} /etc/rc2.d/S90${module_name}

# add menu entry
/var/install/bin/add-menu --menu "setup.services.menu" \
    "setup.services.${module_name}.menu" "owSwitch Service"

# install/update package configuration file
update=false
if install_config ${module_name}
then
    update=true
fi

# configuration
mecho "creating ${module_name} configuration ..."

if [ "${update}" = "true" ]
then
    # updated installation
    /var/install/config.d/${module_name}.sh
    if [ -f /etc/init.d/${module_name} ]
    then
        /etc/init.d/${module_name} restart
    fi
else
    # new installation - parameter check
    /var/install/bin/edit --apply "${module_name}" "Edit ${module_name} services configuration"
fi

# ----------------------------------------------------------------------------
# End
# ----------------------------------------------------------------------------
exit 0
