#!/bin/sh
#------------------------------------------------------------------------------
# /var/install/dialog.d/OWSWITCH_PIO_COUNT.sh
#
# Copyright (c) 2016-2016 the Eisfair team, team(at)eisfair(dot)org>
#
# Creation:     2016-06-13 jed
# Last Update:  $Id: OWSWITCH_PIO_COUNT.sh 41911 2016-06-14 21:38:05Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------

. /var/install/include/cuilib
. /var/install/include/ecelib

#exec 2>/tmp/OWSWITCH_PIO_COUNT-trace-$$.log
#set -x

#----------------------------------------------------------------------------
# exec_dailog
# ece --> request to create and execute dialog
#         $p2 --> main window handle
#         $p3 --> name of config variable
#----------------------------------------------------------------------------
exec_dialog()
{
    local win="${p2}"
    local esource
    local sensorid
    local varname="${p3}"
    local varidx=`echo "${varname}" | sed 's/^OWSWITCH_\([0-9]*\)_.*$/\1/'`

    ece_get_value ${win} OWSWITCH_SOURCE && esource=${p2}
    ece_get_value ${win} OWSWITCH_${varidx}_ID && sensorid=${p2}

    if [ -z "${esource}" ]
    then
        esource='owread'
    fi

    sellist='0'
    echo "${sensorid}" | grep -q "^3A"

    if [ $? -eq 0 ]
    then
        # DS2413 sensor

        case ${esource} in
            owhttp )
                # remote
                ece_get_value ${win} OWSWITCH_OWFS_HOSTNAME && hostname=${p2}
                ece_get_value ${win} OWSWITCH_OWFS_PORT && port=${p2}

                if [ -z "${hostname}" ]
                then
                    hostname="`hostname --fqdn`"
                fi

                if [ -z "${port}" ]
                then
                    port='2121'
                fi

                # '<TR><TD><B>type</B></TD><TD>DS2413</TD></TR>' -> 'DS2413'
                # '<TR><TD><B>sensed.ALL</B></TD><TD>0,0</TD></TR>' -> '0,0' -> 2
                stype=`wget.sh -qO- ${hostname}:${port}/${sensorid} | grep -i '<B>type</B>' | sed 's/^.*<TD>\([^<]*\).*$/\1/i'`
                numval=`wget.sh -qO- ${hostname}:${port}/${sensorid} | grep -i '<B>sensed.ALL</B>' | sed 's/^.*<TD>\([^<]*\).*$/\1/i' |  awk 'BEGIN{FS=","} {print NF}'`
                ;;
            owread )
                # local
                # get sensor type and max. number of pio ports
                stype=`owread ${sensorid}/type`
                numval=`owread ${sensorid}/sensed.ALL | awk 'BEGIN{FS=","} {print NF}'`
                ;;
        esac
    else
        # invalid sensor type
        sellist='0'
    fi

    if [ ! -z "${numval}" ]
    then
        idx=1
        sellist='0'
        while [ ${idx} -le ${numval} ]
        do
            sellist="${sellist},${idx}"

            idx=`expr ${idx} + 1`
        done
    else
        # no value returned
        sellist='0'
    fi

    ece_select_list_dlg "${win}" "${stype} max.PIO ports" "${sellist}"
}

#----------------------------------------------------------------------------
# main routine
#----------------------------------------------------------------------------

cui_init
cui_run

#----------------------------------------------------------------------------
# end
#----------------------------------------------------------------------------
exit 0
